﻿Global hoverTimer


Procedure waitInput()
	Define waitMouse, waitKey
	
	waitMouse = floorUI_mouseInput()
	If waitMouse
		ProcedureReturn waitMouse
	EndIf
	If mouseStatus = 1
		ProcedureReturn #False
	EndIf
	
	waitKey = floorUI_keyInput()
	If waitKey
		ProcedureReturn waitKey
	EndIf
EndProcedure


Procedure floorUI_mouseInput()
	Define leftClick = MouseButton(#PB_MouseButton_Left)
	Define rightClick = MouseButton(#PB_MouseButton_Right)
	Define inputDelay
	Define x, y
	Static doubleClickTimer
	If ElapsedMilliseconds()-doubleClickTimer > doubleClickInterval
		doubleClickTimer = 0
	EndIf
	
	
	;{ TRACKING FUNCTION
	LastElement(actor())
	*track = #Null
	Repeat
		If Not actor()\type = #monsterActor
			Continue
		EndIf
		If actor()\x = xMouse And actor()\y = yMouse
			*track = @actor()
			Break
		EndIf
	Until PreviousElement(actor()) = #Null
	If *track 
		If hoverTimer = 0
			hoverTimer = ElapsedMilliseconds()
		EndIf
		If hoverTimer > 0
			If ElapsedMilliseconds() - hoverTimer > 1
				hoverTimer = -1
			EndIf
		EndIf
	Else
		hoverTimer = 0
	EndIf
	;}
	
	If holdLeft And (Not leftClick) ;sobald die Maustaste losgelassen wird, MouseInput wieder freigeben
		holdLeft = 0
	EndIf
	If holdRight And (Not rightClick) ;sobald die Maustaste losgelassen wird, MouseInput wieder freigeben
		holdright = 0
	EndIf
	
	If Not holdLeft
;		If MouseX() > xOffsetSidebar
;			xMouse = -1
;			yMouse = -1
;		Else
			xMouse = limit(((MouseX()-xMargin)/#xTileSize)+(xViewCenter-xMaxView),0,xMax)
			yMouse = limit(((MouseY()-yMargin)/#yTileSize)+(yViewCenter-yMaxView),0,yMax)
;		EndIf
	EndIf
	
	If xMouse > 0 Or yMouse > 0
		If leftClick
			If Not holdLeft
				holdLeft = 1 ;während die Maustaste gehalten wird, MouseInput sperren, damit Pfad nach dem ersten Schritt nicht erneut aktualisiert wird
				If xMouse = *player\x And yMouse = *player\y
;					holdLeft = 0	;notwendig, für "Warten"-Aktion (gedrückte Maustaste)
;					ProcedureReturn 125
					If doubleClickTimer 
						If ElapsedMilliseconds()-doubleClickTimer <= doubleClickInterval
							openInventory()
							ProcedureReturn 1
						EndIf
					Else
						doubleClickTimer = ElapsedMilliseconds()
					EndIf
				Else
					If ListSize(aStarPath())
						FirstElement(aStarPath())
					EndIf
				EndIf
			Else
				;solange die Maustaste gedrückt bleibt, die nächste PathNode im gefundenen Weg aufrufen
				If NextElement(aStarPath()) <> #Null
					;Check, damit mit gedrückter Maustaste nicht auf dem Zielfeld eines bewegenden Monsters endet
					If collisionMap(aStarPath()\x,aStarPath()\y) >= *player\collision
						ClearList(aStarPath())
						ProcedureReturn 0
					EndIf
					ChangeCurrentElement(actor(),*player)
					xViewCenter = xViewCenter + ((actor()\x-aStarPath()\x)*-1)
					yViewCenter = yViewCenter + ((actor()\y-aStarPath()\y)*-1)
					walk(*player,((actor()\x-aStarPath()\x)*-1),((actor()\y-aStarPath()\y)*-1))
					ProcedureReturn 1
				EndIf
			EndIf
		Else
			If (xMouse <> *player\x Or yMouse <> *player\y) And bresenMap(xMouse,yMouse) ;Or (exploreMap(xMouse,yMouse) And hasMap = 2) )
;				DisableDebugger
				If Not getPath(*player\x,*player\y,xMouse,yMouse,*player,#True)
					ClearList(aStarPath())
				EndIf
;				EnableDebugger
			Else
				ClearList(aStarPath())
			EndIf
		EndIf
		
		If rightClick And (Not (holdLeft Or holdRight))
			If (Not canInteractMap(xMouse,yMouse)) And canInteractMap(*player\x,*player\y)
				xMouse = *player\x
				yMouse = *player\y
			EndIf
			If canInteractMap(xMouse,yMouse)
				holdLeft = 0
				holdRight = 1
				inputDelay = selectAction(xMouse,yMouse)
				ProcedureReturn inputDelay
			EndIf
		EndIf
	EndIf
EndProcedure


Procedure floorUI_keyInput()
	Define dir
	Define count
	Define loadSprites,checkSprites

	Define xCameraNew = xViewCenter
	Define yCameraNew = yViewCenter
	Dim panViewKey(4)
	panViewKey(0) = KeyboardPushed(#PB_Key_C)
	panViewKey(1) = KeyboardPushed(#PB_Key_W)
	panViewKey(2) = KeyboardPushed(#PB_Key_A)
	panViewKey(3) = KeyboardPushed(#PB_Key_D)
	panViewKey(4) = KeyboardPushed(#PB_Key_S)
	Static panTimer
	
	If KeyboardReleased(#PB_Key_I)
		openInventory()
		ProcedureReturn 1
	EndIf
	
	If panTimer
		If ElapsedMilliseconds() -panTimer > 25
			panTimer = 0
		EndIf
	Else
		If panViewKey(0);
			xCameraNew = *player\x
			yCameraNew = *player\y
		EndIf
		For dir = 1 To 4
			If panViewKey(dir)
				xCameraNew = limit(xCameraNew+xMod(dir),*player\x-(xMaxView-1)+((((xMaxView)*2)-1)-lineOfSight),*player\x+(xMaxView-1)-((((xMaxView)*2)-1)-lineOfSight))
				yCameraNew = limit(yCameraNew+yMod(dir),*player\y-(yMaxView-1)+((((yMaxView)*2)-1)-lineOfSight),*player\y+(yMaxView-1)-((((yMaxView)*2)-1)-lineOfSight))
				panTimer = ElapsedMilliseconds()
				Break
			EndIf
		Next
	EndIf
	If xCameraNew <> xViewCenter Or yCameraNew <> yViewCenter
		xViewCenter = xCameraNew
		yViewCenter = yCameraNew
		calculateLOS()		
		updateNegativeView()
	EndIf
	

	;{ RESTART / QUIT / LOAD
	If KeyboardReleased(#PB_Key_Return)
		jobDescription = #newGameJob
	EndIf
	If KeyboardReleased(#PB_Key_Escape)
		jobDescription = #quitJob
	EndIf
	If KeyboardReleased(#PB_Key_F9)
		jobDescription = #loadJob
	EndIf
	;}	
	

	
	If KeyboardReleased(#PB_Key_Tab)
		If *track And *track <> *player
			*debug = *track
			Restore message_monster
		;	setupMessage()
			For count = 0 To #monsterStringMax
		;		mLine$(count) = monsterString(*track\subtype,*track\class,count)			
			Next
		;	createMessage(-1,-1)
		;	displayMessage()
		EndIf
		If *debug
			debugActor()
		Else
			Debug "No Actor tagged!"
		EndIf
	EndIf	
	
	If KeyboardReleased(#PB_Key_Add)
		updateRadiance(1.0,#True)
	EndIf
	If KeyboardReleased(#PB_Key_Subtract)
		updateRadiance(-1.0,#True)
	EndIf
	
	If KeyboardReleased(#PB_Key_F5)
		jobDescription = #saveJob
	EndIf
EndProcedure



Procedure centerCamera()
	If xViewCenter <> *player\x Or yViewCenter <> *player\y	
		xViewCenter = *player\x
		yViewCenter = *player\y
		calculateLOS()		
		updateNegativeView()
	EndIf
EndProcedure


Procedure centerMouse(x,y)
	MouseLocate((x*#xTileSize)+_OffsetX()+(#xTileSize/2),(y*#yTileSize)+_OffsetY()+(#yTileSize/2))
	xMouse = x
	yMouse = y
EndProcedure


; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 72
; FirstLine = 56
; Folding = --
; Markers = 184
; EnableXP