﻿Enumeration 0	;Monster Abilities
	#maNullAbility
EndEnumeration

#monsterSubtypeMax = 1
#monsterClassMax = 2
#monsterSortMax = 0
#monsterFactionMax = 4
Enumeration 0 ;Monster-Faction
	#nullFaction
	#playerFaction
	#monsterFaction
	#npcFaction
	#rogueFaction
EndEnumeration
#monsterConstMax = 28
#monsterFloatMax = 2
#monsterStringMax = 4
Enumeration 0
	#monFaction
	#monCanInteract
	#monCanMove
	#monDrawPriority
	#monCollision
	#monBlockShoot
	#monBlockLoS
	#monInteract	
	#monHP
	#monAbleMelee
	#monAbleRanged
	#monFleeChance
	#monSlots
	#monNimble	
	#monMorale
	#monMeleeKiteChance
	#monRangedKiteChance
	#monRepositionMeleeChance
	#monRepositionRangedChance
	#monApproachRandomChance
	#monFleeRandomChance
	#monStandStillChance
	#monGather
	#monRememberSearch
	#monSearchLimit
	#monMotorSkill
	#monMeleeLow
	#monMeleeHigh
	#monRangedDamage
EndEnumeration
Enumeration 0
	#monVision
	#monRange
	#monSafeDistance
EndEnumeration
Global Dim monsterString.s(#monsterSubtypeMax,#monsterClassMax,#monsterStringMax)
Global Dim monsterConst(#monsterSubtypeMax,#monsterClassMax,#monsterConstMax)
Global Dim monsterFloat.f(#monsterSubtypeMax,#monsterClassMax,#monsterFloatMax)
Global Dim monsterAbility(#monsterSubtypeMax,#monsterClassMax,#monsterAbilityMax)




Procedure readMonsterConst()
	Define mSub
	Define mClass
	Define count
	
	Restore monster_data
	For mSub = 0 To #monsterSubtypeMax
		For mClass = 0 To #monsterClassMax
			For count = 0 To #monsterStringMax
				Read.s monsterString(mSub,mClass,count)
			Next
			For count = 0 To #monsterConstMax
				Read.i monsterConst(mSub,mClass,count)
			Next
			For count = 0 To #monsterFloatMax
				Read.f = monsterFloat(mSub,mClass,count)
			Next
			For count = 0 To #monsterAbilityMax
				Read.i = monsterAbility(mSub,mClass,count)
			Next
			If mSub = 0
				Break
			EndIf
		Next
	Next
EndProcedure


Procedure createMonster(monsterSubtype,monsterClass,x,y)
		actorFactory(#True,_ReadMC(#monCanInteract),#False,_ReadMC(#monCanMove),#False,#False,#True,#False,#False,#False,#False,#False,#False,
		             -1,#monsterActor,monsterSubtype,monsterClass,0,0,Random(1),
		             _ReadMC(#monDrawPriority),#defaultVisibility,_ReadMC(#monCollision),_ReadMC(#monBlockShoot),_ReadMC(#monBlockLoS),_ReadMC(#monInteract),
		             x,y,_ReadMC(#monHP))
		actorToMonster(_ReadMC(#monAbleMelee),_ReadMC(#monAbleRanged),_ReadMC(#monFleeChance),_ReadMC(#monSlots),_ReadMF(#monVision),_ReadMF(#monRange),_ReadMF(#monSafeDistance),
						_ReadMC(#monMeleeLow),_ReadMC(#monMeleeHigh),_ReadMC(#monRangedDamage))
		
		If monsterSubtype = 0
			*player = @actor()
		EndIf
EndProcedure



Procedure actorToMonster(ableMelee,ableRanged,fleeChance,slotsNum,vision.f,range.f,safeDist.f,meleeLow,meleeHigh,rangedDamage)
	Define *origin.ACTOR = @actor()
	
	actor()\ableMelee = ableMelee
	actor()\ableRanged = ableRanged
	actor()\vision = vision
	actor()\fleeChance = fleeChance
	actor()\maxActorRange = range
	actor()\minSafeDistance = safeDist
	actor()\meleeDamageLow = meleeLow
	actor()\meleeDamageHigh = meleeHigh
	actor()\rangedDamage = rangedDamage
	actor()\motorSkill = _MonCon(#monMotorSkill)
	actor()\inCombat = -1

	actor()\IDLE = #True
	actor()\slotsNum = slotsNum
	If slotsNum > #slotsMaxConst
		Debug "Exceeding maximum allowed Monster Slots! "+actor()\index
		End
	EndIf
	
	If monsterConst(actor()\subtype,actor()\class,#monFaction) = #nullFaction
		Debug "Monster with #nullFaction detected! "+actor()\index
		End
	EndIf
EndProcedure


Procedure monsterAction()
	Define x, y
	Define r
	Define count
	Define legit
	Define dir
	Dim newX(indexCounter)
	Dim newY(indexCounter)
	Define lowestDijkstra
	Define *door.ACTOR
	Define *origin.ACTOR
	Define *target.ACTOR
	Define *currentPointer.ACTOR
	Define *tacticReference.ACTOR
	Define hasMoved, hasAttacked
	Define selectMove, selectAttack
	Define dice
	Define msDivisor
	Define eachCount, parentLoop
	
	Enumeration -1
		#randomMove
		#nullMove
		#approachMove
		#fleeMove
		#repositionMove
		#searchMove
	EndEnumeration
	
	Enumeration
		#nullAttack
		#meleeAttack
		#rangedAttack
	EndEnumeration

	_EachActor(#isMonsterP,0)
		If Not actor() = *player
			parentLoop = eachCount

			*currentPointer = @actor()		
			
			*origin = @actor()
			*target = #Null
			checkAttackOptions(*origin)
			ChangeCurrentElement(actor(),*currentPointer)
			If ArraySize(*meleeOption()) <> #Null
				ChangeCurrentElement(actor(),*meleeOption(Random(ArraySize(*meleeOption()),1)))
				*target = @actor()
			EndIf
			If ArraySize(*rangedOption()) <> #Null
				ChangeCurrentElement(actor(),*rangedOption(Random(ArraySize(*rangedOption()),1)))
				*target = @actor()
			EndIf
			*origin = *currentPointer
			If Not *target
				*target = *player
			EndIf	
			
			
			
;			DisableDebugger
			;{ AI ROUTINES
			*tacticReference = *player
			selectMove = #nullMove
			selectAttack = #nullAttack

			If (Not *origin\FLEE)
				If *origin\hp < (_MonCon(#monMorale) * _MonCon(#monHP))/100 And *origin\fleeChance > 0
					If Random(100,1) <= *origin\fleeChance
						*origin\FLEE = #True
						*origin\IDLE = #False
						*origin\SEARCH = #False
						restoreMotorSkill(*origin)
					EndIf
					*origin\fleeChance * -1
				EndIf
			Else
				If *origin\hp >= (_MonCon(#monMorale) * _MonCon(#monHP))/100
					activateIdle(*origin,_MonCon(#monRememberSearch))
				EndIf
			EndIf
			
			If canSee(*origin\x,*origin\y,*tacticReference\x,*tacticReference\y,*origin\vision)
				*origin\xSearch = *tacticReference\x 	;Position des Spielers merken ...
				*origin\ySearch = *tacticReference\y		;... wenn Spieler im Fog of War verschwindet, \SEARCH aktivieren
				*origin\IDLE = #False
				*origin\SEARCH = #False
				*origin\fleeSteps = 0
				*origin\searchCounter = 0
				restoreMotorSkill(*origin)
			EndIf
			
			If canSee(*origin\x,*origin\y,*target\x,*target\y,*origin\vision)
				_Dist(*origin\x,*origin\y,*tacticReference\x,*tacticReference\y) 	;Satz des Pythagoras
				If *origin\ableRanged
					If distance <= *origin\minSafeDistance Or *origin\FLEE
						If isAdjacent(*origin\x,*origin\y,*target\x,*target\y)
							If *origin\ableMelee And (Random(100,1) <= _MonCon(#monMeleeKiteChance) Or *origin\panic > 3)
								selectAttack = #meleeAttack
							Else
								If *origin\ident[#canMoveP]
									If Random(100,1) <= _MonCon(#monRepositionMeleeChance) And (Not *origin\FLEE)
										selectMove = #randomMove
									Else
										selectMove = #fleeMove
									EndIf
								EndIf
							EndIf
						Else
							If isNotBlocked(*origin\x,*origin\y,*target\x,*target\y) And Random(100,1) <= _MonCon(#monRangedKiteChance)
								selectAttack = #rangedAttack
							Else
								If *origin\ident[#canMoveP]
									If Random(100,1) <= _MonCon(#monRepositionMeleeChance) And (Not *origin\FLEE)
										selectMove = #randomMove
									Else
										selectMove = #fleeMove
									EndIf
								EndIf
							EndIf
						EndIf
					Else
						If distance <= *origin\maxActorRange
							If isNotBlocked(*origin\x,*origin\y,*target\x,*target\y) And Random(100,1) > _MonCon(#monRepositionRangedChance) ;> !!!
								selectAttack = #rangedAttack
							Else
								If *origin\ident[#canMoveP]
									If Random(100,1) <= _MonCon(#monRepositionMeleeChance)
										selectMove = #randomMove
									Else
										selectMove = #repositionMove
										If Random(100,1) <= 50 And distance < (*origin\maxActorRange+*origin\minSafeDistance)/2
											selectMove = #fleeMove
										EndIf
									EndIf
								EndIf
							EndIf
						Else
							If *origin\ident[#canMoveP]
								If Random(100,1) <= _MonCon(#monApproachRandomChance)
									selectMove = #randomMove
								Else
									selectMove = #repositionMove
								EndIf
							EndIf
						EndIf
					EndIf
				Else
					If Not *origin\FLEE
						If *origin\ableMelee
							If isAdjacent(*origin\x,*origin\y,*target\x,*target\y)
								If *origin\ident[#canMoveP] And Random(100,1) <= _MonCon(#monRepositionMeleeChance)
									selectMove = #repositionMove
								Else
									selectAttack = #meleeAttack
								EndIf
							Else
								If *origin\ident[#canMoveP]
									If Random(100,1) <= _MonCon(#monApproachRandomChance)
										selectMove = #randomMove
									Else
										selectMove = #approachMove
									EndIf
								EndIf
							EndIf
						Else
							If *origin\ident[#canMoveP]
								selectMove = #randomMove
							EndIf
						EndIf
					Else
						If isAdjacent(*origin\x,*origin\y,*target\x,*target\y) And *origin\ableMelee And Random(100,1) <= _MonCon(#monMeleeKiteChance)
							selectAttack = #meleeAttack
						Else
							If *origin\ident[#canMoveP]
								selectMove = #fleeMove
							EndIf	
						EndIf
					EndIf
				EndIf
			Else
				If *origin\ident[#canMoveP]
					If Not *origin\FLEE
						
						If *origin\SEARCH = #False				
							If *origin\xSearch Or *origin\ySearch
								*origin\IDLE = #False
								*origin\SEARCH = #True
								*origin\searchCounter = 0
								iniSearchDijkstra = #True
							Else
								*origin\IDLE = #True
							EndIf
						EndIf
						If *origin\SEARCH = #True
							If (*origin\x = *origin\xSearch And *origin\y = *origin\ySearch) Or *origin\searchCounter >= _MonCon(#monSearchLimit)
								activateIdle(*origin,#False)
								iniSearchDijkstra = #True
							Else
								*origin\searchCounter +Random(1)
								selectMove = #searchMove
								*origin\IDLE = #False
							EndIf
						EndIf
					Else
						If *origin\fleeSteps > 3
							activateIdle(*origin,_MonCon(#monRememberSearch))
						Else
							selectMove = #fleeMove
							*origin\fleeSteps +1
						EndIf

					EndIf
				EndIf
			EndIf
			
			If *origin\IDLE
				*origin\SEARCH = #False
				*origin\FLEE = #False
				If *origin\ident[#canMoveP] And Random(100,1) > _MonCon(#monStandStillChance)
					selectMove = #randomMove
				EndIf
			EndIf
			If *origin\FLEE And selectMove = #fleeMove
				If Random(10000,1) <= _MonCon(#monFleeRandomChance)
					selectMove = #randomMove
				EndIf
			EndIf
			
			;}
			;EnableDebugger
			
			hasAttacked = #False
			Select selectAttack
				Case #meleeAttack
					hasAttacked = performMeleeAttack(*origin,*target)
				Case #rangedAttack
					hasAttacked = performRangedAttack(*origin,*target)
			EndSelect
			ChangeCurrentElement(actor(),*currentPointer)
			
		
			hasMoved = #False			
			If (Not hasAttacked) And selectMove
				ClearList(chooseDirection())

				lowestDijkstra = highDijkstra
				For dir = 1 To 8
					
					legit = #True
					For count = 1 To #maxExit
						If actor()\x+xMod(dir) = xExit(count) And actor()\y+yMod(dir) = yExit(count)
							legit = #False
						EndIf
					Next
					If dir > 4 And Random(100,1) > _MonCon(#monNimble)
						If collisionMap(actor()\x+xMod(dir)+xSide(dir,1),actor()\y+yMod(dir)+ySide(dir,1)) >= actor()\collision XOr
						   collisionMap(actor()\x+xMod(dir)+xSide(dir,2),actor()\y+yMod(dir)+ySide(dir,2)) >= actor()\collision
							legit = #False
						EndIf
					EndIf
					If legit = #False	
						Continue
					EndIf
					
					msDivisor = 1
					If actor()\IDLE
						msDivisor = 2
					EndIf
					If collisionMap(actor()\x+xMod(dir),actor()\y+yMod(dir)) < actor()\collision Or
							(collisionMap(actor()\x+xMod(dir),actor()\y+yMod(dir)) = #removableCollision And Random(100,1) <= (_MonCon(#monMotorSkill)/msDivisor))
						AddElement(chooseDirection())
						chooseDirection()\val[0] = dir

						If selectMove <> #randomMove
							Select selectMove
								Case #approachMove
									chooseDirection()\val[1] = playerDijkstra(actor()\x+xMod(dir),actor()\y+yMod(dir))	
								Case #fleeMove
									chooseDirection()\val[1] = fleePlayerDijkstra(actor()\x+xMod(dir),actor()\y+yMod(dir))
								Case #repositionMove
									chooseDirection()\val[1] = rangedDijkstra(actor()\x+xMod(dir),actor()\y+yMod(dir))
								Case #searchMove
									chooseDirection()\val[1] = searchDijkstra(actor()\x+xMod(dir),actor()\y+yMod(dir))
							EndSelect
						EndIf
						If _MonCon(#monGather) And (selectMove = #randomMove Or selectMove = #fleeMove)
							chooseDirection()\val[1] + (gatherDijkstra(actor()\x+xMod(dir),actor()\y+yMod(dir))*0.33)
						EndIf
						
						If (Not actor()\IDLE) And actor()\collision < #bigCollision
							For count = 1 To #recentMovesMax-1
								If actor()\x+xMod(chooseDirection()\val[0]) = actor()\xRecent[count] And actor()\y+yMod(chooseDirection()\val[0]) = actor()\yRecent[count]
									chooseDirection()\val[1] = highDijkstra-count
								EndIf
							Next
						EndIf
						If chooseDirection()\val[1] <= lowestDijkstra
							lowestDijkstra = chooseDirection()\val[1]
						EndIf

					EndIf
				Next
				ForEach chooseDirection()
					If chooseDirection()\val[1] <> lowestDijkstra 
						DeleteElement(chooseDirection())
					EndIf
				Next
	
				
				If ListSize(chooseDirection()) <> #Null
					SelectElement(chooseDirection(),Random(ListSize(chooseDirection()),1)-1)
					x = *origin\x+xMod(chooseDirection()\val[0])
					y = *origin\y+yMod(chooseDirection()\val[0])
					
					;{ OPENING DOORS
					If collisionMap(x,y) < #removableCollision
						hasMoved = walk(*origin,xMod(chooseDirection()\val[0]),yMod(chooseDirection()\val[0]))
					Else
						If *origin\motorSkill And Random(100,1) <= *origin\motorSkill
							*origin\motorSkill = limit(*origin\motorSkill*2,0,_MonCon(#monMotorSkill))
							_EachActor(#isDoorP,0)
								If actor()\x = x And actor()\y = y
									*door = @actor()
									If Random(100,1) > (*origin\motorSkill*1.25)
										destroyDoor(*door,*origin\x,*origin\y)
									Else
										shakeDoorAnimation(*door,100)
										hasMoved = createDoor(#False,actor()\subtype,actor()\class,actor()\sort,x,y,Abs(actor()\status-1))
										markForKill(*door)
									EndIf
									Break
								EndIf
							_EndEach()
						Else
							*origin\motorSkill/2
							_EachActor(#isDoorP,0)
								If actor()\x = x And actor()\y = y
									If *origin\motorSkill < (25*_MonCon(#monMotorSkill))/100
										overrideCollision(@actor(),#pathCollision)
										createEffect(#ePathBlocker,actor()\index,actor()\x,actor()\y)
										*origin\motorSkill = _MonCon(#monMotorSkill)
									EndIf
									shakeDoorAnimation(@actor(),200)
									Break
								EndIf
							_EndEach()
							hasMoved = #True
						EndIf
					EndIf
					;}
					
				EndIf
				
			EndIf
			
			;Check Panic
			If (Not (hasMoved Or hasAttacked)) Or *origin\ableRanged = #True
				count = 0
				Dim *openListActor(count)
				If *origin\ableMelee 
					_EachActor(#isMonsterP,0)
						If isEnemy(*origin,@actor()) And isAdjacent(actor()\x,actor()\y,*origin\x,*origin\y)
							count +1
							ReDim *openListActor(count)
							*openListActor(count) = @actor()
						EndIf
					_EndEach()
					If count > 0
						dice = Random(count,1)
						If Not (hasMoved Or hasAttacked)
							hasAttacked = performMeleeAttack(*origin,*openListActor(dice))
						EndIf
						If *origin\ableRanged
							*origin\panic +1
						EndIf
					Else
						*origin\panic = 0
					EndIf
				EndIf
			EndIf
			
			checkInCombat(*currentPointer)
			If canSee(*origin\x,*origin\y,*player\x,*player\y,*origin\vision)
				*origin\xSearch = *player\x 	;Position des Spielers merken ...
				*origin\ySearch = *player\y		;... wenn Spieler im Fog of War verschwindet, \SEARCH aktivieren
				*origin\IDLE = #False
				*origin\SEARCH = #False
				*origin\fleeSteps = 0
				*origin\searchCounter = 0			
			EndIf
			
			eachCount = parentLoop
		EndIf

	_EndEach()
	calculateLOS()
EndProcedure


Procedure isEnemy(*requester.ACTOR,*compare.ACTOR)
	If monsterConst(*requester\subtype,*requester\class,#monFaction) = monsterConst(*compare\subtype,*compare\class,#monFaction)
		ProcedureReturn #False
	EndIf
	If monsterConst(*requester\subtype,*requester\class,#monFaction) <> monsterConst(*compare\subtype,*compare\class,#monFaction)
		If monsterConst(*requester\subtype,*requester\class,#monFaction) = #npcFaction Or monsterConst(*compare\subtype,*compare\class,#monFaction) = #npcFaction
			ProcedureReturn #False
		EndIf
	EndIf
	ProcedureReturn #True
EndProcedure


Procedure checkInCombat(*origin.ACTOR)
	Define eachCount
	
	If *origin\inCombat > -1
		*origin\inCombat +1
		If *origin\inCombat > 4
			*origin\inCombat = -1
		EndIf
	Else
		_EachActor(#isMonsterP,0)
			If monsterConst(actor()\subtype,actor()\class,#monFaction) <> _MonCon(#monFaction)
				_Dist(*origin\x,*origin\y,actor()\x,actor()\y)
				If distance <= inCombatRange
					*origin\inCombat = 0
					ProcedureReturn #False
				EndIf
			EndIf
		_EndEach()
		*origin\hp = limit(*origin\hp+1,1,_MonCon(#monHP))
	EndIf
EndProcedure


Procedure activateIdle(*subject.ACTOR,rememberSearch)
	*subject\FLEE = #False
	*subject\IDLE = #True
	*subject\SEARCH = #False
	If Not rememberSearch
		*subject\xSearch = 0
		*subject\ySearch = 0
	EndIf
	*subject\fleeChance = Abs(*subject\fleeChance)
EndProcedure


Procedure checkAttackOptions(*origin.ACTOR)
	Define eachCount
	Dim count(1)
	Dim *meleeOption(0)
	Dim *rangedOption(0)
	_EachActor(#isMonsterP,0)
		If isEnemy(*origin,@actor())
			If canSee(*origin\x,*origin\y,actor()\x,actor()\y,*origin\vision) And isNotBlocked(*origin\x,*origin\y,actor()\x,actor()\y)
				If isAdjacent(*origin\x,*origin\y,actor()\x,actor()\y)
					count(0) +1
					ReDim *meleeOption(count(0))
					*meleeOption(count(0)) = @actor()
				Else
					If *origin\x <> actor()\x Or *origin\y <> actor()\y ;Kein Fernkampf wenn auf selbem Feld!
						count(1) +1
						ReDim *rangedOption(count(1))
						*rangedOption(count(1)) = @actor()
					EndIf
				EndIf
			EndIf
		EndIf
	_EndEach()
EndProcedure


Procedure canSee(x,y,xTarget,yTarget,vision)
	Define canSee
	Dim bresenSave(0,0)
	
	_Dist(x,y,xTarget,yTarget)
	If distance > vision
		ProcedureReturn #False
	EndIf
	
	If xTarget = *player\x And yTarget = *player\y And bresenMap(x,y) And distance <= radiance
		canSee = #True
	Else
		CopyArray(bresenRef(),bresenSave())
		bresenRef(x,y) = 0
		bresenRef(xTarget,yTarget) = 0
		If getBresenham(x,y,xTarget,yTarget,0) ;strenger Bresenham (ohne wayBack!)
			canSee = #True
		EndIf
		
		CopyArray(bresenSave(),bresenRef())
	EndIf
	
	ProcedureReturn canSee
EndProcedure


Procedure isNotBlocked(x,y,xTarget,yTarget)
	Define isNotBlocked
	Dim bresenSave(0,0)
	
	CopyArray(bresenRef(),bresenSave())
	CopyArray(blockShootMap(),bresenRef())
	bresenRef(x,y) = 0
	bresenRef(xTarget,yTarget) = 0
	
	If getBresenham(x,y,xTarget,yTarget,0) Or getBresenham(xTarget,yTarget,x,y,0) ;Bresenham ist asymmetrisch!
		isNotBlocked = #True
	EndIf
	
	CopyArray(bresenSave(),bresenRef())
	ProcedureReturn isNotBlocked
EndProcedure


Procedure restoreMotorSkill(*origin.ACTOR)
	Define count
	Define legit
	
	If *origin\motorSkill < _MonCon(#monMotorSkill)
		legit = #True
		For count = 1 To #recentMovesMax
			If *origin\xRecent[count] = *origin\x And *origin\yRecent[count] = *origin\y
				legit = #False
				Break
			EndIf
		Next
		If legit
			*origin\motorSkill = _MonCon(#monMotorSkill)
		EndIf
	EndIf
EndProcedure






DataSection
monster_data:
	;{ PLAYER
	Data.s "This is you",""
	Data.s "Our humble Hero."
	Data.s "Please don't die!"
	Data.s ""
	
	Data.i #playerFaction		;	#monFaction	
	Data.i #False				;	#monCanInteract
	Data.i #True				;	#monCanMove
	Data.i #playerDepth			;	#monDrawPriority
	Data.i #defaultCollision	;	#monCollision
	Data.i #True				;	#monBlockShoot
	Data.i #False				;	#monBlockLoS
	Data.i #nullInteract		;	#monInteract	
	Data.i 1000000				;	#monHP
	Data.i #True				;	#monAbleMelee
	Data.i #False				;	#monAbleRanged
	Data.i 0					;	#monFleeChance
	Data.i #slotsInitial		;	#monSlots
	Data.i 0					;	#monNimble	
	Data.i 0					;	#monMorale
	Data.i 0					;	#monMeleeKiteChance
	Data.i 0					;	#monRangedKiteChance
	Data.i 0					;	#monRepositionMeleeChance (für Ranged Monster Chance zufälligen Move statt Abstand zu halten)
	Data.i 0					;	#monRepositionRangedChance
	Data.i 0					;	#monApproachRandomChance
	Data.i 00000				;	#monFleeRandomChance
	Data.i 0					;	#monStandStillChance
	Data.i #False				;	#monGather
	Data.i #False				;	#monRememberSearch
	Data.i 0					;	#monSearchLimit
	Data.i 0					;	#monMotorSkill
	Data.i 2					;	#monMeleeLow
	Data.i 6					;	#monMeleeHigh
	Data.i 3					;	#monRangedDamage
	
	Data.f 18.5					;	#monVision
	Data.f #rangedMax			;	#monRange
	Data.f 0					;	#monSafeDistance
	
	Data.i #False				;	#maNullAbility
	;}

	;{ NORMAL MONSTER
	Data.s "Generic Low Level Monster",""
	Data.s "Will run at you and hit you."
	Data.s "Seriously, that's all it's good for"
	Data.s "(main source of XP-income)."
	
	Data.i #monsterFaction		;	#monFaction	
	Data.i #True				;	#monCanInteract
	Data.i #True				;	#monCanMove
	Data.i #monsterDepth		;	#monDrawPriority
	Data.i #defaultCollision	;	#monCollision
	Data.i #True				;	#monBlockShoot
	Data.i #False				;	#monBlockLoS
	Data.i #rangedInteract		;	#monInteract	
	Data.i 16					;	#monHP
	Data.i #True				;	#monAbleMelee
	Data.i #False				;	#monAbleRanged
	Data.i 35					;	#monFleeChance
	Data.i 0					;	#monSlots
	Data.i 0					;	#monNimble	
	Data.i 25					;	#monMorale
	Data.i 16					;	#monMeleeKiteChance
	Data.i 0					;	#monRangedKiteChance
	Data.i 25					;	#monRepositionMeleeChance (für Ranged Monster Chance zufälligen Move statt Abstand zu halten)
	Data.i 0					;	#monRepositionRangedChance
	Data.i 16					;	#monApproachRandomChance
	Data.i 00750				;	#monFleeRandomChance
	Data.i 40					;	#monStandStillChance
	Data.i #False				;	#monGather
	Data.i #True				;	#monRememberSearch
	Data.i 40					;	#monSearchLimit
	Data.i 40					;	#monMotorSkill
	Data.i 1					;	#monMeleeLow
	Data.i 4					;	#monMeleeHigh
	Data.i 0					;	#monRangedDamage
	
	Data.f 13.0					;	#monVision
	Data.f 0.0					;	#monRange
	Data.f 1.0					;	#monSafeDistance
	
	Data.i #False				;	#maNullAbility
	;}
	
	;{ FLYING MONSTER
	Data.s "Annoying Bat",""
	Data.s "Every RPG has 'em."
	Data.s "Only a threat in large numbers."
	Data.s ""
	
	Data.i #monsterFaction		;	#monFaction	
	Data.i #True				;	#monCanInteract
	Data.i #True				;	#monCanMove
	Data.i #bigMonsterDepth		;	#monDrawPriority
	Data.i #bigCollision		;	#monCollision
	Data.i #True				;	#monBlockShoot
	Data.i #False				;	#monBlockLoS
	Data.i #rangedInteract		;	#monInteract	
	Data.i 12					;	#monHP
	Data.i #True				;	#monAbleMelee
	Data.i #False				;	#monAbleRanged
	Data.i 75					;	#monFleeChance
	Data.i 0					;	#monSlots
	Data.i 100					;	#monNimble	
	Data.i 90					;	#monMorale
	Data.i 33					;	#monMeleeKiteChance
	Data.i 0					;	#monRangedKiteChance
	Data.i 45					;	#monRepositionMeleeChance (für Ranged Monster Chance zufälligen Move statt Abstand zu halten)
	Data.i 0					;	#monRepositionRangedChance
	Data.i 32					;	#monApproachRandomChance
	Data.i 02000				;	#monFleeRandomChance
	Data.i 16					;	#monStandStillChance
	Data.i #True				;	#monGather
	Data.i #False				;	#monRememberSearch
	Data.i 20					;	#monSearchLimit
	Data.i 20					;	#monMotorSkill
	Data.i 1					;	#monMeleeLow
	Data.i 3					;	#monMeleeHigh
	Data.i 0					;	#monRangedDamage
	
	Data.f 6.5					;	#monVision
	Data.f 1.0					;	#monRange
	Data.f 1.0					;	#monSafeDistance
	
	Data.i #False				;	#maNullAbility
	;}	
	
	;{ RANGED MONSTER
	Data.s "Green Monster",""
	Data.s "Also annoying."
	Data.s "Shoots stuff at you."
	Data.s ""
	
	Data.i #monsterFaction		;	#monFaction
	Data.i #True				;	#monCanInteract
	Data.i #True				;	#monCanMove
	Data.i #monsterDepth		;	#monDrawPriority
	Data.i #defaultCollision	;	#monCollision
	Data.i #True				;	#monBlockShoot
	Data.i #False				;	#monBlockLoS
	Data.i #rangedInteract		;	#monInteract	
	Data.i 10					;	#monHP
	Data.i #True				;	#monAbleMelee
	Data.i #True				;	#monAbleRanged
	Data.i 25					;	#monFleeChance
	Data.i 0					;	#monSlots
	Data.i 77					;	#monNimble	
	Data.i 33					;	#monMorale
	Data.i 15					;	#monMeleeKiteChance
	Data.i 35					;	#monRangedKiteChance
	Data.i 20					;	#monRepositionMeleeChance (für Ranged Monster Chance zufälligen Move statt Abstand zu halten)
	Data.i 66					;	#monRepositionRangedChance
	Data.i 9					;	#monApproachRandomChance
	Data.i 00500				;	#monFleeRandomChance
	Data.i 85					;	#monStandStillChance
	Data.i #False				;	#monGather
	Data.i #False				;	#monRememberSearch
	Data.i 20					;	#monSearchLimit
	Data.i 90					;	#monMotorSkill
	Data.i 1					;	#monMeleeLow
	Data.i 2					;	#monMeleeHigh
	Data.i 2					;	#monRangedDamage
	
	Data.f 12.0					;	#monVision
	Data.f 8.0					;	#monRange
	Data.f 3.5					;	#monSafeDistance
	
	Data.i #False				;	#maNullAbility
	;}	
EndDataSection
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 607
; FirstLine = 607
; Folding = ---
; EnableXP