﻿Procedure saveCoreData()
	Define fileOut	
	Define count
	
	If ExamineDirectory(0,"SAVEGAMES\","")
		FinishDirectory(0)
	Else
		If Not CreateDirectory("SAVEGAMES\")
			Debug "CreateDirectory() failed!"
		EndIf
	EndIf

	
	fileName$ = "SAVEGAMES\dungeonSave"
	fileOut = CreateFile(#PB_Any,fileName$)
	If fileOut
		For count = 0 To #maxGameID
			WriteInteger(fileOut,gameID(count))
		Next
		
		;Index Counter!!!
;		WriteInteger(fileOut,indexCounter)
;		For count = 1 To indexCounter
;			WriteByte(fileOut,indexLib(count))
;		Next
		
		;LevelIndex
		WriteInteger(fileOut,dFloor)
		WriteInteger(fileOut,globalFloorIndex)
		
		;Teleporter
		WriteInteger(fileOut,ListSize(teleport()))
		ForEach teleport()
			For count = 0 To 1
				WriteInteger(fileOut,teleport()\dFloor[count])
				WriteInteger(fileOut,teleport()\x[count])
				WriteInteger(fileOut,teleport()\y[count])
			Next
			WriteByte(fileOut,teleport()\active)
			WriteInteger(fileOut,teleport()\charges)
		Next
		
		CloseFile(fileOut)
	EndIf
EndProcedure


Procedure saveFloor(includePlayer)
	Define fileOut
	Define count
	Define x, y
	
	fileName$ = "SAVEGAMES\dFloor"+Str(dFloor)
	fileOut = CreateFile(#PB_Any,fileName$)
	If fileOut
		For count = 0 To #maxGameID
			WriteInteger(fileOut,gameID(count))
		Next
		
		;xMax / yMax
		WriteInteger(fileOut,xMax)
		WriteInteger(fileOut,yMax)
		
		;Freie Felder
		count = 0
		ForEach freeField()
			count +1
		Next
		WriteInteger(fileOut,count)
		ForEach freeField()
			WriteInteger(fileOut,freeField()\x)
			WriteInteger(fileOut,freeField()\y)
			WriteInteger(fileOut,freeField()\value)
		Next
		
		;Exits
		For count = 0 To #maxExit
			WriteInteger(fileOut,xExit(count))
			WriteInteger(fileOut,yExit(count))
		Next
		
		;exploreMap
		For x = 0 To xMax
			For y = 0 To yMax
				WriteInteger(fileOut,exploreMap(x,y))
			Next
		Next
		
		;Anzahl Actors
		count = 0
		ForEach actor()
			If Not actor()\ident[#isTempAnimationP] And Not actor()\ident[#isGadgetP] And Not actor()\ident[#isDimensionP] And Not actor()\index = *player\index And Not actor()\hp = 0
				count +1
			EndIf
		Next
		If includePlayer
			ForEach actor()
				If actor()\index = *player\index And actor()\hp <> 0
					count +1
				EndIf
			Next
		EndIf
		WriteInteger(fileOut,count)
		
		;Übrige Actors	
		ForEach actor()
			If actor()\hp = 0
				Continue
			EndIf
			If actor()\index = *player\index And (Not includePlayer)
				Continue
			EndIf
			If actor()\ident[#isTempAnimationP] Or actor()\ident[#isGadgetP] Or actor()\ident[#isDimensionP]
				Continue
			EndIf
			
			For count = 0 To #actorPointerMax
				WriteByte(fileOut,actor()\ident[count])
			Next
			WriteInteger(fileOut,actor()\visible)
			WriteByte(fileOut,actor()\blockShoot)
			WriteByte(fileOut,actor()\blockLoS)
			
			WriteByte(fileOut,actor()\FLEE)
			WriteByte(fileOut,actor()\IDLE)
			WriteByte(fileOut,actor()\SEARCH)
			WriteInteger(fileOut,actor()\x)
			WriteInteger(fileOut,actor()\y)
			WriteInteger(fileOut,actor()\type)
			WriteInteger(fileOut,actor()\subtype)
			WriteInteger(fileOut,actor()\class)
			WriteInteger(fileOut,actor()\sort)
			WriteInteger(fileOut,actor()\quality)
			WriteInteger(fileOut,actor()\status)
			WriteInteger(fileOut,actor()\interaction)
			WriteInteger(fileOut,actor()\drawPriority)
			WriteInteger(fileOut,actor()\collision)
			WriteInteger(fileOut,actor()\xMicro)
			WriteInteger(fileOut,actor()\yMicro)
			WriteInteger(fileOut,actor()\hp)
			
			WriteInteger(fileOut,actor()\index)
			For count = 0 To #recentMovesMax
				WriteInteger(fileOut,actor()\xRecent[count])
				WriteInteger(fileOut,actor()\yRecent[count])
			Next
			WriteInteger(fileOut,actor()\fleeSteps)
			WriteInteger(fileOut,actor()\inCombat)
			
			WriteByte(fileOut,actor()\ableMelee)
			WriteByte(fileOut,actor()\ableRanged)
			WriteFloat(fileOut,actor()\vision)
			WriteInteger(fileOut,actor()\fleeChance)
			WriteFloat(fileOut,actor()\maxActorRange)
			WriteFloat(fileOut,actor()\minSafeDistance)	
			WriteInteger(fileOut,actor()\motorSkill)
			WriteInteger(fileOut,actor()\slotsNum)
			
			WriteInteger(fileOut,actor()\xSearch)
			WriteInteger(fileOut,actor()\ySearch)
			WriteInteger(fileOut,actor()\searchCounter)
			WriteInteger(fileOut,actor()\panic)
			WriteInteger(fileOut,actor()\alpha)
			WriteInteger(fileOut,actor()\frameMax)
			WriteInteger(fileOut,actor()\animTimer)
			WriteInteger(fileOut,actor()\animLimit)
			WriteInteger(fileOut,actor()\killTimer)
			WriteInteger(fileOut,actor()\killLimit)
			WriteInteger(fileOut,actor()\invLocation)
			WriteInteger(fileOut,actor()\stacks)
			WriteInteger(fileOut,actor()\durability)
			For count = 0 To #propertyMax
				WriteInteger(fileOut,actor()\property[count])
			Next
			WriteInteger(fileOut,actor()\meleeDamageLow)
			WriteInteger(fileOut,actor()\meleeDamageHigh)
			WriteInteger(fileOut,actor()\rangedDamage)
		Next
		
		CloseFile(fileOut)
	Else
		Debug "File could not be saved!"
		End
	EndIf
EndProcedure


Procedure loadCoreData()
	Define c, count
	Define fileIn
	Define maxNum
	

	fileName$ = "SAVEGAMES\dungeonSave"
	If FileSize(fileName$) > -1
		fileIn = OpenFile(#PB_Any,fileName$)
		
		For count = 0 To #maxGameID
			gameID(count) = ReadInteger(fileIn)
		Next
		
		;Index-Library
;		indexCounter = ReadInteger(fileIn)
;		Dim indexLib(indexCounter)
;		For count = 1 To indexCounter
;			indexLib(count) = ReadByte(fileIn)
;		Next
		
		;Dungeon Level
		dFloor = ReadInteger(fileIn)
		globalFloorIndex = ReadInteger(fileIn)
		
		;Teleporter
		maxNum = ReadInteger(fileIn)
		If maxNum > 0
			For count = 1 To maxNum
				AddElement(teleport())
				For c = 0 To 1
					teleport()\dFloor[c] = ReadInteger(fileIn)
					teleport()\x[c] = ReadInteger(fileIn)
					teleport()\y[c] = ReadInteger(fileIn)
				Next
				teleport()\active = ReadByte(fileIn)
				teleport()\charges = ReadInteger(fileIn)
			Next
		EndIf

		CloseFile(fileIn)
	EndIf
EndProcedure


Procedure loadFloor()
	Define fileIn
	Define maxNum
	Define count
	Define x, y
	Define c
	
	;{ DEFINE TEMP_VARIABLES
	Dim tempByte_ident(#actorPointerMax)
	Define tempInteger_visible	
	Define tempByte_blockShoot
	Define tempByte_blockLoS
	Define _VARtempByte_FLEE
	Define _VARtempByte_IDLE
	Define _VARtempByte_SEARCH
	Define tempInt_x
	Define tempInt_y
	Define tempInt_type
	Define tempInt_subtype
	Define tempInt_class
	Define tempInt_sort
	Define tempInt_quality
	Define tempInt_status
	Define tempInt_interaction
	Define tempInt_drawPriority
	Define tempInt_collision
	Define _VARtempInt_xMicro
	Define _VARtempInt_yMicro
	Define _VARtempInt_hp
	Define tempInt_index
	Dim _VARtempInt_xRecent(#recentMovesMax)
	Dim _VARtempInt_yRecent(#recentMovesMax)
	Define _VARtempInt_fleeSteps
	Define _VARtempInt_inCombat
	Define tempByte_ableMelee
	Define tempByte_ableRanged
	Define tempFloat_vision
	Define tempInt_fleeChance
	Define tempFloat_maxActorRange
	Define tempFloat_minSafeDistance
	Define _VARtempInt_motorSkill
	Define tempInt_slotsNum	
	Define _VARtempInt_xSearch
	Define _VARtempInt_ySearch
	Define _VARtempInt_searchCounter
	Define _VARtempInt_panic
	Define tempInt_alpha
	Define tempInt_frameMax
	Define tempInt_animTimer
	Define tempInt_animLimit
	Define tempInt_killTimer
	Define tempInt_killLimit
	Define _VARtempInt_invLocation
	Define tempInt_stacks
	Define tempInt_durability
	Dim propertyTemp(#propertyMax)
	Define tempInt_meleeDamageLow
	Define tempInt_meleeDamageHigh
	Define tempInt_rangedDamage
	;}	
	
	fileName$ = "SAVEGAMES\dFloor"+Str(dFloor)
	If FileSize(fileName$) > -1
		fileIn = OpenFile(#PB_Any,fileName$)
		
		For count = 0 To #maxGameID
			c = ReadInteger(fileIn)
			If c <> gameID(count)
				Debug "floorData corrupted!"
				End
			EndIf
		Next
		
		;xMax / yMax
		xMax = ReadInteger(fileIn)
		yMax = ReadInteger(fileIn)	
		clearFloor(xMax,yMax)
		
		;Anzahl der freien Felder
		maxNum = ReadInteger(fileIn)
		For count = 1 To maxNum
			x = ReadInteger(fileIn)
			y = ReadInteger(fileIn)
			floorMap(x,y) = ReadInteger(fileIn)
		Next
		translateFloor()
		
		;Exits
		For count = 0 To #maxExit
			xExit(count) = ReadInteger(fileIn)
			yExit(count) = ReadInteger(fileIn)
		Next
		
		;exploreMap
		For x = 0 To xMax
			For y = 0 To yMax
				exploreMap(x,y) = ReadInteger(fileIn)
			Next
		Next
		
		maxNum = ReadInteger(fileIn) ;Anzahl der Actors
		For count = 1 To maxNum
			For c = 0 To #actorPointerMax
				tempByte_ident(c) = ReadByte(fileIn)
			Next
			tempInteger_visible = ReadInteger(fileIn)			
			tempByte_blockShoot = ReadByte(fileIn)
			tempByte_blockLoS = ReadByte(fileIn)
			_VARtempByte_FLEE = ReadByte(fileIn)
			_VARtempByte_IDLE = ReadByte(fileIn)
			_VARtempByte_SEARCH = ReadByte(fileIn)
			tempInt_x = ReadInteger(fileIn)
			tempInt_y = ReadInteger(fileIn)
			tempInt_type = ReadInteger(fileIn)
			tempInt_subtype = ReadInteger(fileIn)
			tempInt_class = ReadInteger(fileIn)
			tempInt_sort = ReadInteger(fileIn)
			tempInt_quality = ReadInteger(fileIn)
			tempInt_status = ReadInteger(fileIn)
			tempInt_interaction = ReadInteger(fileIn)
			tempInt_drawPriority = ReadInteger(fileIn)
			tempInt_collision = ReadInteger(fileIn)
			_VARtempInt_xMicro = ReadInteger(fileIn)
			_VARtempInt_yMicro = ReadInteger(fileIn)
			_VARtempInt_hp = ReadInteger(fileIn)
			tempInt_index = ReadInteger(fileIn)
			
	
			For c = 0 To #recentMovesMax
				_VARtempInt_xRecent(c) = ReadInteger(fileIn)
				_VARtempInt_yRecent(c) = ReadInteger(fileIn)
			Next


			_VARtempInt_fleeSteps = ReadInteger(fileIn)
			_VARtempInt_inCombat = ReadInteger(fileIn)
			
			tempByte_ableMelee = ReadByte(fileIn)
			tempByte_ableRanged = ReadByte(fileIn)
			tempFloat_vision = ReadFloat(fileIn)
			tempInt_fleeChance = ReadInteger(fileIn)
			tempFloat_maxActorRange = ReadFloat(fileIn)
			tempFloat_minSafeDistance = ReadFloat(fileIn)
			_VARtempInt_motorSkill = ReadInteger(fileIn)	
			
			tempInt_slotsNum = ReadInteger(fileIn)			
			_VARtempInt_xSearch = ReadInteger(fileIn)
			_VARtempInt_ySearch = ReadInteger(fileIn)
			_VARtempInt_searchCounter = ReadInteger(fileIn)
			_VARtempInt_panic = ReadInteger(fileIn)
			tempInt_alpha = ReadInteger(fileIn)
			tempInt_frameMax = ReadInteger(fileIn)
			tempInt_animTimer = ReadInteger(fileIn)
			tempInt_animLimit = ReadInteger(fileIn)
			tempInt_killTimer = ReadInteger(fileIn)
			tempInt_killLimit = ReadInteger(fileIn)
			_VARtempInt_invLocation = ReadInteger(fileIn)
			tempInt_stacks = ReadInteger(fileIn)
			tempInt_durability = ReadInteger(fileIn)
			For c = 0 To #propertyMax
				propertyTemp(c) = ReadInteger(fileIn)
			Next
			tempInt_meleeDamageLow = ReadInteger(fileIn)
			tempInt_meleeDamageHigh = ReadInteger(fileIn)
			tempInt_rangedDamage = ReadInteger(fileIn)
			

			
			actorFactory(tempByte_ident(#hasImageP),tempByte_ident(#canInteractP),tempByte_ident(#isDoorP),tempByte_ident(#canMoveP),tempByte_ident(#isAnimationP),
								tempByte_ident(#isTempAnimationP),tempByte_ident(#isMonsterP),tempByte_ident(#isItemP),tempByte_ident(#isChildP),
								tempByte_ident(#isEffectP),tempByte_ident(#isTriggerP),#False,#False,
								tempInt_index,tempInt_type,tempInt_subtype,tempInt_class,tempInt_sort,tempInt_quality,tempInt_status,tempInt_drawPriority,
								tempInteger_visible,tempInt_collision,tempByte_blockShoot,tempByte_blockLoS,tempInt_interaction,tempInt_x,tempInt_y,_VARtempInt_hp)
			
			
			actor()\alpha = tempInt_alpha
			
			If tempByte_ident(#isMonsterP)
				actorToMonster(tempByte_ableMelee,tempByte_ableRanged,tempInt_fleeChance,tempInt_slotsNum,tempFloat_vision,tempFloat_maxActorRange,tempFloat_minSafeDistance,
								tempInt_meleeDamageLow,tempInt_meleeDamageHigh,tempInt_rangedDamage)
			EndIf
			If tempByte_ident(#isItemP)
				actorToItem(tempInt_stacks,tempInt_durability)
			EndIf
			If tempByte_ident(#isAnimationP)
				If tempInt_animTimer <> 0
					tempInt_animTimer = ElapsedMilliseconds()
				EndIf
				If tempInt_killTimer <> 0
					tempInt_killTimer = ElapsedMilliseconds()
				EndIf
				actorToAnimation(0,tempInt_alpha,tempInt_frameMax,tempInt_animTimer,tempInt_animLimit,tempInt_killTimer,tempInt_killLimit)
			EndIf
			If actor()\type = #effectActor
				actor()\killTimer = tempInt_killTimer
				actor()\killLimit = tempInt_killLimit
			EndIf
			For c = 0 To #recentMovesMax
				actor()\xRecent[c] = _VARtempInt_xRecent(c)
				actor()\yRecent[c]= _VARtempInt_yRecent(c)
			Next
			actor()\fleeSteps = _VARtempInt_fleeSteps
			actor()\FLEE = _VARtempByte_FLEE
			actor()\IDLE = _VARtempByte_IDLE
			actor()\SEARCH = _VARtempByte_SEARCH
			actor()\hp = _VARtempInt_hp
			actor()\searchCounter = _VARtempInt_searchCounter
			actor()\panic = _VARtempInt_panic
			actor()\xMicro = _VARtempInt_xMicro
			actor()\yMicro = _VARtempInt_yMicro
			actor()\xSearch = _VARtempInt_xSearch
			actor()\ySearch = _VARtempInt_ySearch
			actor()\inCombat = _VARtempInt_inCombat
			actor()\motorSkill = _VARtempInt_motorSkill
			actor()\invLocation = _VARtempInt_invLocation
		Next
		translateFloor()
		
		CloseFile(fileIn)
	Else
		Debug "File could not be loaded!"
		End
	EndIf
EndProcedure
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 97
; FirstLine = 71
; Folding = v
; EnableXP