﻿Global Dim keyColorText$(#maxLockedSort)
Restore string_keyColors
For a = 1 To #maxLockedSort
	Read.s keyColorText$(a)
Next

#maxMessageLines = 16
Global welcomeMessage
Global Dim mLine$(#maxMessageLines)
Global Dim mLineFont(#maxMessageLines)
Global Dim isOption(#maxMessageLines)
Global xMess,yMess,messCentered
Global messageLineNum
Global defaultCanvas,canvasColor,borderColor
Global headerColor,textColor,optionColor,selectionColor
Global optionLine
Global ySelectionPick,ySelectionHeight

#maxFont = 10
Global Dim font(#maxFont)
If RegisterFontFile("MODES___.ttf")
	font(0) = LoadFont(#PB_Any,"ModeSeven",8,#PB_Font_Bold)
	font(1) = LoadFont(#PB_Any,"ModeSeven",11)
	font(2) = LoadFont(#PB_Any,"ModeSeven",11,#PB_Font_Bold)
	font(3) = LoadFont(#PB_Any,"ModeSeven",14)
	font(4) = LoadFont(#PB_Any,"ModeSeven",14,#PB_Font_Bold)
	font(5) = LoadFont(#PB_Any,"ModeSeven",17)
	font(6) = LoadFont(#PB_Any,"ModeSeven",20)
	font(7) = LoadFont(#PB_Any,"ModeSeven",24)
	font(8) = LoadFont(#PB_Any,"ModeSeven",28)
	font(9) = LoadFont(#PB_Any,"ModeSeven",34)
	font(10) = LoadFont(#PB_Any,"ModeSeven",40)
Else
	Debug "Font not found on this computer!"
	End
EndIf

Global messageSPR
Global tempMessageSPR
Global selectorSPR



Procedure iniMessage(fontSize)
	Define i
	
	For i = 0 To #maxMessageLines
		mLine$(i) = ""
		mLineFont(i) = fontSize
		isOption(i) = #True
	Next
	defaultCanvas = #cDark
	borderColor = #cWood
	headerColor = #cSand
	textColor = #cSand
	optionColor = #cSilver
	selectionColor = #cSand
	optionLine = -1
EndProcedure


Procedure setupMessage()
	Define count
	Define iniFontValue, numFontDefine
	Define fontLine
	Define numMessageLines
	Define lineIndex
	
	Read.i iniFontValue
	Read.i numFontDefine
	iniMessage(iniFontValue)
	If numFontDefine > -1
		For count = 0 To numFontDefine
			Read.i fontLine
			Read.i mLineFont(fontLine)
		Next
	EndIf
	Read.i numMessageLines
	Dim lineIndex(numMessageLines)
	For count = 0 To numMessageLines
		Read.i lineIndex(count)
	Next
	For count = 0 To numMessageLines
		Read.s mLine$(lineIndex(count))
	Next
	Read.i canvasColor
	If canvasColor > -1
		Read.i borderColor
		Read.i headerColor
		Read.i textColor
		Read.i optionColor
		Read.i selectionColor
	Else
		canvasColor = defaultCanvas
	EndIf
	Read.i optionLine
EndProcedure


Procedure createMessage(x,y,borderWidth)
	Define i
	Define width, height
	Define xOffset = 20
	Define yOffset = 20
	Define xTolerance = 45
	Define yTolerance = 25
	Define ySpace
	Define tColor = headerColor
	Define optionStart
	
	For i = #maxMessageLines To 0 Step -1
		If mLine$(i) <> ""
			messageLineNum = #maxMessageLines-(#maxMessageLines-i)
			Break
		EndIf
	Next
	If IsSprite(messageSPR)
		FreeSprite(messageSPR)
	EndIf
	If IsSprite(tempMessageSPR)
		FreeSprite(tempMessageSPR)
	EndIf	
	tempMessageSPR = CreateSprite(#PB_Any,#xRes,#yRes)
	If IsScreenActive() And StartDrawing(SpriteOutput(tempMessageSPR))
		
		If canvasColor = -1
			canvasColor = #cSand
		EndIf
		
		FillArea(0,0,-1,color(canvasColor))
		_TText()
		For i = 0 To messageLineNum
			If i > 0
				tColor = textColor
			EndIf
			If i >= optionLine And optionLine > -1
				tColor = optionColor
				mLine$(i) = Space(5)+mLine$(i)
				If Not isOption(i)
					tColor = #cStone
				EndIf
			EndIf			
			
			DrawingFont(FontID(font(mLineFont(i))))	
			If TextWidth(mLine$(i)) > width
				width = TextWidth(mLine$(i))
			EndIf
			If mLine$(i) = ""
				mLine$(i) = Space(1)
			EndIf
			
			DrawText(xOffset,yOffset+height,mLine$(i),color(tColor))
			height + TextHeight(mLine$(i))+(TextHeight(mLine$(i))/2)
			If i = optionLine
				ySelectionPick = height-(TextHeight(mLine$(i))/2)
				ySelectionHeight = TextHeight(mLine$(i))+(TextHeight(mLine$(i))/2)
			EndIf
		Next
		
		width + xTolerance
		height + yOffset + yTolerance
		_DMode0()
		For i = 0 To borderWidth
			Box(i,i,width-(i*2),height-(i*2),color(borderColor))
		Next
		StopDrawing()
	EndIf
	DisplaySprite(tempMessageSPR,0,0)
	messageSPR = GrabSprite(#PB_Any,0,0,limit(width,0,#xRes),limit(height,0,#yRes))
	
	xMess = x
	yMess = y
	messCentered = #False
	If xMess = -1 Or yMess = -1
		messCentered = #True
	EndIf
EndProcedure


Procedure displayMessage()
	Define x, y, xSize, ySize
	Define count
	Define mesAlpha = 255
	Define exitMessage
	Define restoreMouseX = MouseX()
	Define restoreMouseY = MouseY()
	Define xSelectionOffset = 44
	Define xSelectionMargin = 56
	Define selection
	Define mouseAlpha
	Define leftClick, rightClick
	
	If optionLine > -1
		x = SpriteWidth(messageSPR)-xSelectionMargin
		y = ySelectionHeight
		If IsSprite(selectorSPR)
			FreeSprite(selectorSPR)
		EndIf
		selectorSPR = CreateSprite(#PB_Any,x,y)
		If IsScreenActive() And StartDrawing(SpriteOutput(selectorSPR))
			Box(0,0,x,y,color(selectionColor))
			StopDrawing()
		EndIf	
	EndIf
	
	If messCentered
		xMess = ((((xMaxView*2)+1)*#xTileSize)/2)-(SpriteWidth(messageSPR)/2)
		yMess = ((((yMaxView*2)+1)*#yTileSize)/2)-(SpriteHeight(messageSPR)/2)
	EndIf
	MouseLocate(xMess+20,yMess+SpriteHeight(messageSPR)-20)
	Repeat
		hideMouse = #True	;kein InteractionRectangle zeigen
		_Display()
		hideMouse = #False
		DisplayTransparentSprite(messageSPR,xMess,yMess,mesAlpha)
		
		ExamineMouse()
		ExamineKeyboard()	
		leftClick = 0
		rightClick = 0
		
		If MouseX() < xMess Or MouseX() > xMess+SpriteWidth(messageSPR) Or MouseY() < yMess Or MouseY() > yMess+SpriteHeight(messageSPR)
			mesAlpha = limit(mesAlpha-6,50,255)
			mouseAlpha = 255
		Else
			mouseAlpha = 33
			mesAlpha = 255	
		EndIf
		
		If optionLine > -1
			selection = 0
			For count = optionLine To messageLineNum
				x = xMess+xSelectionOffset
				y = ySelectionPick+yMess+((count-optionLine)*ySelectionHeight)
				xSize = SpriteWidth(messageSPR)-xSelectionMargin
				ySize = ySelectionHeight
				
				If MouseX() > x And MouseX() < x+xSize And MouseY() > y And MouseY() < y+ySize And isOption(count)
					selection = (count-optionLine)+1
					DisplayTransparentSprite(selectorSPR,x,y,100)
					mouseAlpha = 255
				EndIf
			Next
		EndIf
		leftClick = MouseButton(#PB_MouseButton_Left)
		rightClick = MouseButton(#PB_MouseButton_Right)
		
		If KeyboardReleased(#PB_Key_Escape)
			selection = 0
			exitMessage = #True
		EndIf
		If mouseAlpha = 255 And (leftClick Or KeyboardReleased(#PB_Key_Space) Or (rightClick And (Not selection)))
			exitMessage = #True
		EndIf
		
		drawMouse(mouseAlpha)
		_MyFlip()
	Until exitMessage Or cancelSubMenu()
	If Not IsScreenActive()	:	selection = 0 : EndIf
	holdLeft = 1
	MouseLocate(restoreMouseX,restoreMouseY)

	ProcedureReturn selection
EndProcedure






DataSection
string_keyColors:
	Data.s "Wooden Key","Bronze Key","Silver Key","Golden Key"
	
message_welcome:
	Data.i 1,2	;iniFontValue, numFontDefine
	Data.i 0,2,13,0,14,0
	Data.i 12	;numMessageLines
	Data.i 0,2,3,4,5,6,7,8,9,10,11,13,14
	Data.s "    Welcome, Hero, to the Underworld."
	Data.s "Persephone, Daughter of Demeter and Mistress of the"
	Data.s "Lord of the Underworld, has gone missing."
	Data.s "She was last seen picking Pomegranates in the Garden"
	Data.s "of Hades, when a sudden gust of wind seized her"
	Data.s "delicate figure and carried her off into an abyss."
	Data.s "Now it's up to you to descend into the depth of"
	Data.s "Tartarus, smite whatever dangers you may encounter,"
	Data.s "find Persephone and guide her back to safety."
    Data.s "If you succeed, the Lord of the Underworld will"
    Data.s "grant you a second chance in life."
	Data.s "                                   (Press ESC or"
	Data.s "                       click outside the Canvas)"
	Data.i -1,-1
	
message_genericStone:
	Data.i 1,-1
	Data.i 3
	Data.i 0,1,2,4
	Data.s "Permadeath does not concern us, because"
	Data.s "as long as we exist, death is not here."
	Data.s "And when it does come, we no longer exist."
	Data.s "           Epicurus (rogue philosopher)"
	Data.i -1,-1
	
message_doorInteraction:
	Data.i 1,-1
	Data.i 5
	Data.i 0,1,2,4,5,6
	Data.s "A door blocks the path."
	Data.s "As you examine the lock, you"
	Data.s "notice a particular pattern."
	Data.s "Use a "
	Data.s "Break with Melee Weapon"
	Data.s "Force open with your weight"
	Data.i -1
	Data.i 4 ;OptionStart
	
message_doorWarning:
	Data.i 1,-1
	Data.i 2
	Data.i 0,1,3
	Data.s "If you close this door, you'll"
	Data.s "need another key to open it again."
	Data.s "Close the Door"
	Data.i -1
	Data.i 3
	
message_lightBrazier:
	Data.i 1,-1
	Data.i 3
	Data.i 0,1,2,4
	Data.s "There's a metal brazier here."
	Data.s "The flame is extinct, yet the"
	Data.s "coals are warm and glowing."
	Data.s "Light the Fire"
	Data.i -1 ;OptionalColor
	Data.i 4

message_monster:
	Data.i 1,-1
	Data.i #monsterStringMax
	Data.i 0,1,2,3,4
	Data.s "","","","",""
	Data.i -1,-1
EndDataSection


; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 259
; FirstLine = 228
; Folding = -
; EnableXP